Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEAction.c
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEAction.c	(revision 106)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEAction.c	(revision 106)
@@ -0,0 +1,314 @@
+/*
+ *  ICeCoffEEAction.c
+ *  ICeCoffEE APE
+ *
+ *  Created by Nicholas Riley on Wed Jan 29 2003.
+ *  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+ *
+ */
+
+#include "ICeCoffEEAction.h"
+#include "ICeCoffEEConfig.h"
+#include "ICeCoffEEShared.h"
+#include "ICeCoffEEBookmarks.h"
+
+/* thanks to Slava Karpenko for this one! */
+OSStatus _LSCopyApplicationURLsForItemURL(CFURLRef inURL, LSRolesMask inRoleMask, CFArrayRef *outApps); // outApps to be CFReleased()
+
+#define THROW_ERR(e) { err = e; goto END; }
+
+static CFStringRef ICCF_NameWithLocation(CFStringRef name, CFURLRef url) {
+    CFURLRef urlMinus = CFURLCreateCopyDeletingLastPathComponent(NULL, url);
+    CFStringRef urlString = CFURLCopyFileSystemPath(urlMinus, kCFURLPOSIXPathStyle);
+    CFStringRef nameWithLocationTemplate = ICCF_CopyLocalizedString(CFSTR("App%@Location%@"));
+    CFStringRef nameWithLocation = CFStringCreateWithFormat(NULL, NULL, nameWithLocationTemplate, name, urlString);
+    
+    SAFE_RELEASE(nameWithLocationTemplate);
+    SAFE_RELEASE(urlMinus);
+    SAFE_RELEASE(urlString);
+    return nameWithLocation;
+}
+
+static const MenuItemIndex kICAppMenuItemHasPath = 0xfffe;
+
+typedef struct {
+    CFURLRef defaultAppURL; // URL of default app, set to NULL after added to menu
+    CFMutableSetRef appPaths;
+    CFMutableDictionaryRef appItemTitles; // keys: URLs; values: item titles (CFString)
+    CFMutableDictionaryRef appURLs; // keys: app display names (CFString), values: URL of item without path appended, or NULL if already appended (at least 2 items with this name exist)
+    MenuRef menu;
+} icAppMenuContext;
+
+static OSStatus ICCF_AddAppItemTitle(icAppMenuContext *ctx, CFURLRef appURL) {
+    CFStringRef appName = NULL, appItemTitle = NULL;
+    CFBundleRef appBundle = NULL;
+    OSStatus err = noErr;
+
+    CFStringRef appPath = CFURLCopyPath(appURL);
+    // only one entry for each path
+    if (CFSetContainsValue(ctx->appPaths, appPath))
+        return dupFNErr;
+    CFSetAddValue(ctx->appPaths, appPath);
+
+    if ( (err = LSCopyDisplayNameForURL(appURL, &appName)) != noErr)
+        return err;
+
+    // if we encounter multiple applications with the same display name, add locations to the menu item titles to disambiguate them
+    CFURLRef sameAppURL;
+    Boolean shouldAppendLocation;
+    if ( (shouldAppendLocation = CFDictionaryGetValueIfPresent(ctx->appURLs, appName, (const void **)&sameAppURL)) && (CFTypeRef)sameAppURL != kCFNull) {
+        // this app is the second encountered with the same name; go back and fix the menu item title of the first app
+        CFStringRef sameAppItemTitle = CFDictionaryGetValue(ctx->appItemTitles, sameAppURL);
+        CFStringRef appItemTitleWithVersion = ICCF_NameWithLocation(sameAppItemTitle, sameAppURL);
+        CFDictionarySetValue(ctx->appItemTitles, sameAppURL, appItemTitleWithVersion);
+        SAFE_RELEASE(appItemTitleWithVersion);
+        CFDictionarySetValue(ctx->appURLs, appName, kCFNull);
+    }
+
+    CFRetain(appName);
+    appItemTitle = appName;
+
+    if ( (appBundle = CFBundleCreate(NULL, appURL)) != NULL) {
+        // prefer a short version string, e.g. "1.0 Beta" instead of "51" for Safari
+        CFStringRef appVersion = CFBundleGetValueForInfoDictionaryKey(appBundle, CFSTR("CFBundleShortVersionString"));
+        if (appVersion == NULL)
+            appVersion = CFBundleGetValueForInfoDictionaryKey(appBundle, kCFBundleVersionKey);
+        if (appVersion != NULL) {
+            appItemTitle = CFStringCreateWithFormat(NULL, NULL, CFSTR("%@ (%@)"), appName, appVersion);
+            CFRelease(appName);
+        }
+        CFRelease(appBundle);
+    }
+
+    if (shouldAppendLocation) {
+        CFStringRef appItemTitleWithVersion = ICCF_NameWithLocation(appItemTitle, appURL);
+        CFRelease(appItemTitle);
+        appItemTitle = appItemTitleWithVersion;
+    } else {
+        CFDictionarySetValue(ctx->appURLs, appName, appURL);
+    }
+
+    if (ctx->defaultAppURL != NULL && CFEqual(appURL, ctx->defaultAppURL)) {
+        CFStringRef defaultFormat = ICCF_CopyLocalizedString(CFSTR("DefaultApp%@"));
+        CFStringRef appItemTitleWithDefault = CFStringCreateWithFormat(NULL, NULL, defaultFormat, appItemTitle);
+        CFRelease(appItemTitle);
+        appItemTitle = appItemTitleWithDefault;
+        ctx->defaultAppURL = NULL; // mark as added
+    }
+
+    CFDictionarySetValue(ctx->appItemTitles, appURL, appItemTitle);
+    CFRelease(appItemTitle);
+
+    return noErr;
+}
+
+static OSStatus ICCF_AddTitledAppToMenu(icAppMenuContext *ctx, CFURLRef appURL, MenuCommand menuCommand) {
+    CFStringRef appItemTitle = NULL;
+    IconRef appIcon = NULL;
+    FSRef appFSR;
+    SInt16 label;
+    MenuItemIndex menuItemIndex;
+    OSStatus err = noErr;
+
+    appItemTitle = CFDictionaryGetValue(ctx->appItemTitles, appURL);
+    if (appItemTitle == NULL) return fnfErr;
+    
+    err = AppendMenuItemTextWithCFString(ctx->menu, appItemTitle, 0, 0, &menuItemIndex);
+    if (err != noErr) return err;
+
+    if (!CFURLGetFSRef(appURL, &appFSR)) return paramErr;
+    err = GetIconRefFromFileInfo(&appFSR, 0, NULL, kFSCatInfoNone, NULL, kIconServicesNormalUsageFlag, &appIcon, &label);
+    if (err != noErr) return err;
+
+    SetMenuItemIconHandle(ctx->menu, menuItemIndex, kMenuIconRefType, (Handle)appIcon);
+    SetMenuItemCommandID(ctx->menu, menuItemIndex, menuCommand);
+    SetMenuItemRefCon(ctx->menu, menuItemIndex, (UInt32)appURL);
+    ReleaseIconRef(appIcon);
+
+    return err;
+}
+
+static OSStatus ICCF_AddAppToMenu(icAppMenuContext *ctx, CFURLRef appURL, MenuCommand menuCommand) {
+    OSStatus err = ICCF_AddAppItemTitle(ctx, appURL);
+    switch (err) {
+        case noErr: break;
+        case dupFNErr: return noErr;
+        default: return err;
+    }
+    return ICCF_AddTitledAppToMenu(ctx, appURL, menuCommand);
+}    
+
+CFComparisonResult ICCF_CompareURLsByItemTitle(const void *url1, const void *url2, void *appItemTitles) {
+    CFStringRef appItemTitle1 = CFDictionaryGetValue((CFDictionaryRef)appItemTitles, (CFURLRef)url1);
+    CFStringRef appItemTitle2 = CFDictionaryGetValue((CFDictionaryRef)appItemTitles, (CFURLRef)url2);
+    return CFStringCompareWithOptions(appItemTitle1, appItemTitle2,
+                                      CFRangeMake(0, CFStringGetLength(appItemTitle1)),
+                                      kCFCompareCaseInsensitive | kCFCompareNumerically);
+}
+
+enum {
+    kICURLActionOpenWith = 'OpnW',
+    kICURLActionAddBookmark = 'AddB'
+};
+
+OSStatus ICCF_DoURLActionMenu(ICInstance inst, CFURLRef url, LSLaunchFlags launchFlags) {
+    CFArrayRef appURLsUnsorted = NULL; // matching app URLs
+    CFMutableArrayRef appURLs = NULL; // matching app URLs sorted by item title
+    CFArrayRef urlArray = NULL; // single-URL array
+    icAppMenuContext ctx = {NULL, NULL, NULL, NULL};
+    OSStatus err;
+    
+    if ( (err = _LSCopyApplicationURLsForItemURL(url, kLSRolesAll, &appURLsUnsorted)) != noErr)
+        THROW_ERR(err);
+
+    CFIndex appCount = 0;
+    if (appURLsUnsorted == NULL || (appCount = CFArrayGetCount(appURLsUnsorted)) == 0)
+        THROW_ERR(kLSApplicationNotFoundErr);
+
+    if ( (appURLs = CFArrayCreateMutableCopy(NULL, appCount, appURLsUnsorted)) == NULL)
+        THROW_ERR(memFullErr);
+
+    if ( (ctx.appPaths = CFSetCreateMutable(NULL, appCount, &kCFCopyStringSetCallBacks)) == NULL)
+        THROW_ERR(memFullErr);
+
+    if ( (ctx.appItemTitles = CFDictionaryCreateMutable(NULL, appCount, &kCFTypeDictionaryKeyCallBacks, &kCFTypeDictionaryValueCallBacks)) == NULL)
+        THROW_ERR(memFullErr);
+
+    if ( (ctx.appURLs = CFDictionaryCreateMutable(NULL, appCount, &kCFCopyStringDictionaryKeyCallBacks, &kCFTypeDictionaryValueCallBacks)) == NULL)
+        THROW_ERR(memFullErr);
+
+    LSGetApplicationForURL(url, kLSRolesAll, NULL, &ctx.defaultAppURL);
+
+    CFIndex appIndex;
+    CFURLRef appURL;
+    for (appIndex = 0 ; appIndex < appCount ; appIndex++) {
+        appURL = CFArrayGetValueAtIndex(appURLs, appIndex);
+        err = ICCF_AddAppItemTitle(&ctx, appURL);
+        switch (err) {
+            case noErr: break;
+            case dupFNErr:
+                CFArrayRemoveValueAtIndex(appURLs, appIndex);
+                appIndex--;
+                appCount--;
+                break;
+            default:
+                THROW_ERR(err);
+        } 
+    }
+
+    CFArraySortValues(appURLs, CFRangeMake(0, appCount), ICCF_CompareURLsByItemTitle, ctx.appItemTitles);
+    
+    if ( (err = CreateNewMenu(0, kMenuAttrExcludesMarkColumn, &ctx.menu)) != noErr)
+        THROW_ERR(err);
+    
+    MenuItemIndex menuItemIndex;
+    if ( (err = AppendMenuItemTextWithCFString(ctx.menu, ICCF_CopyLocalizedString(CFSTR("Open Location With")), kMenuItemAttrDisabled, 0, &menuItemIndex)) != noErr)
+        THROW_ERR(err);
+
+    if ( (urlArray = CFArrayCreate(NULL, (const void **)&url, 1, &kCFTypeArrayCallBacks)) == NULL)
+        THROW_ERR(memFullErr);
+
+    for (appIndex = 0 ; appIndex < appCount ; appIndex++) {
+        appURL = CFArrayGetValueAtIndex(appURLs, appIndex);
+
+        if ( (err = ICCF_AddTitledAppToMenu(&ctx, appURL, kICURLActionOpenWith)) != noErr)
+            THROW_ERR(err);
+    }
+    // sometimes the default protocol handler won't be on the list because it doesnÕt claim to handle that protocol; add it anyway
+    if (ctx.defaultAppURL != NULL) {
+        if ( (err = ICCF_AddAppToMenu(&ctx, ctx.defaultAppURL, kICURLActionOpenWith)) != noErr)
+            THROW_ERR(err);
+    }
+
+    appURL = ICCF_GetBookmarkHelperURL(inst);
+    if (appURL != NULL) {
+        if ( (err = AppendMenuItemTextWithCFString(ctx.menu, CFSTR(""), kMenuItemAttrSeparator, 0, NULL)) != noErr)
+            THROW_ERR(err);
+        if ( (err = AppendMenuItemTextWithCFString(ctx.menu, ICCF_CopyLocalizedString(CFSTR("Add Bookmark")), kMenuItemAttrDisabled, 0, &menuItemIndex)) != noErr)
+            THROW_ERR(err);
+        // the app won't show up at the bottom if someone cmd-option-clicks on 'bookmark:', but they'd have to be crazy to do that anyway
+        if ( (err = ICCF_AddAppToMenu(&ctx, appURL, kICURLActionAddBookmark)) != noErr)
+            THROW_ERR(err);
+    }
+    
+    InsertMenu(ctx.menu, -1);
+    Point mousePoint;
+    GetGlobalMouse(&mousePoint);
+    long selectedAppIndex = PopUpMenuSelect(ctx.menu, mousePoint.v + 18, mousePoint.h - 30, 0/*popUpItem*/);
+    if (selectedAppIndex == 0) {
+        err = userCanceledErr;
+    } else {
+        CFURLRef appURL = NULL;
+        MenuCommand menuCommand;
+        err = GetMenuItemRefCon(ctx.menu, selectedAppIndex, (void *)&appURL);
+        if (err == noErr) {
+            err = GetMenuItemCommandID(ctx.menu, selectedAppIndex, &menuCommand);
+            if (err == noErr) {
+                if (menuCommand == kICURLActionOpenWith) {
+                    LSLaunchURLSpec lsSpec = {appURL, urlArray, NULL, launchFlags};
+                    err = LSOpenFromURLSpec(&lsSpec, NULL);
+                } else if (menuCommand == kICURLActionAddBookmark) {
+                    err = ICCF_DoBookmarkDialog(inst, CFURLGetString(url));
+                }
+            }
+        }
+    }
+    
+END:
+    if (ctx.menu != NULL) {
+        DeleteMenu(GetMenuID(ctx.menu));
+        DisposeMenu(ctx.menu);
+    }
+    SAFE_RELEASE(urlArray);
+    SAFE_RELEASE(appURLsUnsorted);
+    SAFE_RELEASE(appURLs);
+    SAFE_RELEASE(ctx.appPaths);
+    SAFE_RELEASE(ctx.appItemTitles);
+    SAFE_RELEASE(ctx.appURLs);
+    
+    return err;
+}
+
+OSStatus ICCF_DoURLActionLaunch(ICInstance inst, CFURLRef url, LSLaunchFlags launchFlags) {
+    CFArrayRef urlArray = CFArrayCreate(NULL, (const void **)&url, 1, &kCFTypeArrayCallBacks);
+    LSLaunchURLSpec lsSpec = {NULL, urlArray, NULL, launchFlags, NULL};
+    OSStatus err;
+
+    if (urlArray == NULL)
+        THROW_ERR(memFullErr);
+
+    err = LSOpenFromURLSpec(&lsSpec, NULL);
+
+END:
+    SAFE_RELEASE(urlArray);
+
+    return err;
+}
+
+OSStatus ICCF_DoURLAction(ICInstance inst, ConstStr255Param hint, const char *urlData, long startIndex, long endIndex, iccfURLAction action) {
+    Handle h = NewHandle(0);
+    CFURLRef url = NULL;
+    LSLaunchFlags launchFlags = kLSLaunchDefaults;
+    OSStatus err;
+
+    if (h == NULL) return MemError();
+
+    if ( (err = ICParseURL(inst, hint, urlData + startIndex, endIndex - startIndex + 1,
+                           &startIndex, &endIndex, h)) != noErr) THROW_ERR(err);
+
+    if ( (url = CFURLCreateWithBytes(NULL, *h, GetHandleSize(h), kCFStringEncodingASCII,
+                                     NULL)) == NULL) THROW_ERR(paramErr);
+
+    if (action.launchInBackground) launchFlags |= kLSLaunchDontSwitch;
+
+    if (action.presentMenu)
+        err = ICCF_DoURLActionMenu(inst, url, launchFlags);
+    else
+        err = ICCF_DoURLActionLaunch(inst, url, launchFlags);
+
+END:
+    if (h != NULL) DisposeHandle(h);
+    SAFE_RELEASE(url);
+
+    return err;
+}
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEAction.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEAction.h	(revision 106)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEAction.h	(revision 106)
@@ -0,0 +1,24 @@
+/*
+ *  ICeCoffEEAction.h
+ *  ICeCoffEE APE
+ *
+ *  Created by Nicholas Riley on Wed Jan 29 2003.
+ *  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+ *
+ */
+
+#ifndef _H_ICeCoffEEAction
+#define _H_ICeCoffEEAction
+
+#include <Carbon/Carbon.h>
+
+// per-action options
+
+typedef struct {
+    Boolean presentMenu;
+    Boolean launchInBackground;
+} iccfURLAction;
+
+OSStatus ICCF_DoURLAction(ICInstance inst, ConstStr255Param hint, const char *urlData, long startIndex, long endIndex, iccfURLAction action);
+
+#endif /* _H_ICeCoffEEAction */
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEBookmarks.c
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEBookmarks.c	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEBookmarks.c	(revision 106)
@@ -133,4 +133,5 @@
 
     err = AESend(&event, &nullReply, kAENoReply, kAENormalPriority, kNoTimeOut, nil, nil);
+    (void)AEDisposeDesc(&event);
     if (err != noErr) return err;
 
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEConfig.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEConfig.h	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEConfig.h	(revision 106)
@@ -12,4 +12,5 @@
 
 #include <CoreFoundation/CoreFoundation.h>
+#include "ICeCoffEEAction.h"
 
 // constants
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEShared.h	(revision 106)
@@ -13,5 +13,6 @@
 #include <CoreFoundation/CoreFoundation.h>
 
-#define ICCF_DEBUG 0
+#define ICCF_DEBUG 1
+#define ICCF_WEBKIT 0
 
 #if ICCF_DEBUG
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETerminal.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETerminal.m	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETerminal.m	(revision 106)
@@ -365,5 +365,5 @@
         [[self superview] display];
 
-        ICCF_LaunchURL(s, ICCF_OptionKeyIsDown());
+        ICCF_LaunchURL(s, ICCF_KeyboardAction());
         
         if (ICCF_prefs.textBlinkEnabled) {
@@ -403,5 +403,4 @@
     ICLog(@"ICeCoffEE Terminal up: %@", upEvent);
     [super mouseUp: upEvent];
-    // don't want command-option-click, command-shift-click, etc. to trigger
     if (ICCF_downEvent != nil) {
         NSPoint downPt = [ICCF_downEvent locationInWindow];
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETextEdit.c
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETextEdit.c	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEETextEdit.c	(revision 106)
@@ -13,5 +13,4 @@
 #include "ICeCoffEEConfig.h"
 #include "ICeCoffEEShared.h"
-#include "ICeCoffEEActionMenu.h"
 #include <ApplicationEnhancer/ApplicationEnhancer.h>
 
@@ -24,11 +23,11 @@
 //		Private function prototypes
 //-----------------------------------------------------------------------------
-void	ICCF_LaunchURLFromTEClick(TEHandle teH, short oldSelStart, short oldSelEnd, Boolean optionKey);
-OSStatus ICCF_DoCommandClick(TEHandle teH, long selStart, long selEnd, Boolean optionKey);
+void	ICCF_LaunchURLFromTEClick(TEHandle teH, short oldSelStart, short oldSelEnd, iccfURLAction action);
+OSStatus ICCF_DoCommandClick(TEHandle teH, long selStart, long selEnd, iccfURLAction action);
 
 //=============================================================================
 //		ICCF_LaunchURLFromTEClick : TEClick addition.
 //-----------------------------------------------------------------------------
-void	ICCF_LaunchURLFromTEClick(TEHandle teH, short oldSelStart, short oldSelEnd, Boolean optionKey)
+void	ICCF_LaunchURLFromTEClick(TEHandle teH, short oldSelStart, short oldSelEnd, iccfURLAction action)
 {
     OSStatus			err;
@@ -40,5 +39,5 @@
             oldSelEnd = (**teH).selEnd;
         }
-        err = ICCF_DoCommandClick(teH, oldSelStart, oldSelEnd, optionKey);
+        err = ICCF_DoCommandClick(teH, oldSelStart, oldSelEnd, action);
         if (err != noErr && err != userCanceledErr) {
             ICapeprintf("ICCF_DoCommandClick failed: %ld\n", err);
@@ -106,5 +105,5 @@
 //		ICCF_DoCommandClick : Handle the click.
 //-----------------------------------------------------------------------------
-OSStatus	ICCF_DoCommandClick(TEHandle teH, long selStart, long selEnd, Boolean optionKey)
+OSStatus	ICCF_DoCommandClick(TEHandle teH, long selStart, long selEnd, iccfURLAction action)
 {
     ICInstance inst = NULL;
@@ -130,30 +129,14 @@
         if (thePort != NULL) QDFlushPortBuffer(thePort, NULL);
 
-        if (optionKey) {
-            Handle urlH = NewHandle(0);
-            if (urlH == NULL) {
-                err = MemError();
-            } else {
-                err = ICParseURL(inst, hint, *textH, GetHandleSize(textH), &selStart, &selEnd, urlH);
-                if (err == noErr) {
-                    if (needsSlashes) ICCF_AddSlashes(urlH, hint);
-                    err = ICCF_DoURLActionMenu(inst, hint, *urlH, 0, GetHandleSize(urlH));
-                }
-                DisposeHandle(urlH);
+        Handle urlH = NewHandle(0);
+        if (urlH == NULL) {
+            err = MemError();
+        } else {
+            err = ICParseURL(inst, hint, *textH, GetHandleSize(textH), &selStart, &selEnd, urlH);
+            if (err == noErr) {
+                if (needsSlashes) ICCF_AddSlashes(urlH, hint);
+                err = ICCF_DoURLAction(inst, hint, *urlH, 0, GetHandleSize(urlH), action);
             }
-        } else {
-            if (needsSlashes) {
-                Handle urlH = NewHandle(0);
-                err = ICParseURL(inst, hint, *textH, GetHandleSize(textH), &selStart, &selEnd, urlH);
-                if (err == noErr) {
-                    ICCF_AddSlashes(urlH, hint);
-                    // don't want to disturb text selection
-                    long tmpEnd = GetHandleSize(urlH);
-                    long tmpStart = 0;
-                    err = ICLaunchURL(inst, hint, *urlH, GetHandleSize(urlH), &tmpStart, &tmpEnd);
-                }
-            } else {
-                err = ICLaunchURL(inst, hint, *textH, GetHandleSize(textH), &selStart, &selEnd);
-            }
+            DisposeHandle(urlH);
         }
         
@@ -196,5 +179,8 @@
     // Do our thing
     if (modifiers & cmdKey) {
-        ICCF_LaunchURLFromTEClick(teH, oldSelStart, oldSelEnd, (modifiers & optionKey) != 0);
+        iccfURLAction action;
+        action.presentMenu = (modifiers & optionKey) != 0;
+        action.launchInBackground = (modifiers & shiftKey) != 0;
+        ICCF_LaunchURLFromTEClick(teH, oldSelStart, oldSelEnd, action);
     }
     ICapeprintf("ICCF_TEClick exited\n");
Index: /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEWebKit.m
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEWebKit.m	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/ICeCoffEEWebKit.m	(revision 106)
@@ -83,4 +83,5 @@
         WebCoreBridge *bridge = [(WebHTMLView *)self _bridge];
         ICCF_GetWebCoreBridgeSelection(bridge, &selection);
+        ICLog(@"selection start %d@%@ end %d@%@ string %@", [bridge selectionStartOffset], [bridge selectionStart], [bridge selectionEndOffset], [bridge selectionEnd], [bridge selectedString]);
         // XXX hack until we have something better
         [selectedString release]; selectedString = nil;
@@ -117,5 +118,6 @@
             // XXX works, but doesn't update
             ICCF_StartIC();
-            ICCF_LaunchURL(selectedString, ICCF_OptionKeyIsDown());
+            ICCF_LaunchURL(selectedString, ICCF_KeyboardAction());
+            // breaks in Safari v62 and before
             ICCF_SetWebCoreBridgeSelection(bridge, &selection);
             if (ICCF_prefs.textBlinkEnabled) {
@@ -133,6 +135,6 @@
 
         ICCF_StopIC();
+        // XXX need to release fromNode, toNode
 
-        // ICLog(@"selection start %d end %d string %@", [bridge selectionStartOffset], [bridge selectionEndOffset], [bridge selectedString]);
         // [bridge forceLayout];
         // ICLog(@"force start %d end %d string %@", [bridge selectionStartOffset], [bridge selectionEndOffset], [bridge selectedString]);
Index: /trunk/ICeCoffEE/ICeCoffEE/Installer components/ui/ui.plist
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/Installer components/ui/ui.plist	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/Installer components/ui/ui.plist	(revision 106)
@@ -39,9 +39,9 @@
 	<string>ICeCoffEE</string>
 	<key>ProductNumVersion</key>
-	<integer>20021248</integer>
+	<integer>20078593</integer>
 	<key>ProductType</key>
 	<string>Preference Pane</string>
 	<key>ProductVersion</key>
-	<string>1.3.1</string>
+	<string>1.3.2b1</string>
 </dict>
 </plist>
Index: /trunk/ICeCoffEE/ICeCoffEE/Japanese.lproj/APE Manager plugin.nib/classes.nib
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/Japanese.lproj/APE Manager plugin.nib/classes.nib	(revision 106)
+++ /trunk/ICeCoffEE/ICeCoffEE/Japanese.lproj/APE Manager plugin.nib/classes.nib	(revision 106)
@@ -0,0 +1,31 @@
+{
+    IBClasses = (
+        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {
+            ACTIONS = {
+                commandClickEnabled = id; 
+                errorDialogEnabled = id; 
+                errorSoundEnabled = id; 
+                servicesInContextualMenu = id; 
+                servicesInMenuBar = id; 
+                textBlinkCount = id; 
+                textBlinkEnabled = id; 
+            }; 
+            CLASS = ICeCoffEEController; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {
+                commandClickEnabled = NSButton; 
+                errorDialogEnabled = NSButton; 
+                errorSoundEnabled = NSButton; 
+                servicesInContextualMenu = NSButton; 
+                servicesInMenuBar = NSButton; 
+                tabView = NSTabView; 
+                textBlinkCount = NSPopUpButton; 
+                textBlinkEnabled = NSButton; 
+                window = NSWindow; 
+            }; 
+            SUPERCLASS = NSObject; 
+        }
+    ); 
+    IBVersion = 1; 
+}
Index: /trunk/ICeCoffEE/ICeCoffEE/Japanese.lproj/APE Manager plugin.nib/info.nib
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/Japanese.lproj/APE Manager plugin.nib/info.nib	(revision 106)
+++ /trunk/ICeCoffEE/ICeCoffEE/Japanese.lproj/APE Manager plugin.nib/info.nib	(revision 106)
@@ -0,0 +1,45 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IBDocumentLocation</key>
+	<string>355 114 356 240 0 0 1280 832 </string>
+	<key>IBFramework Version</key>
+	<string>291.0</string>
+	<key>IBGroupedObjects</key>
+	<dict>
+		<key>1</key>
+		<array>
+			<string>253</string>
+			<string>256</string>
+			<string>258</string>
+			<string>260</string>
+			<string>262</string>
+			<string>263</string>
+			<string>264</string>
+			<string>266</string>
+			<string>270</string>
+		</array>
+	</dict>
+	<key>IBLastGroupID</key>
+	<string>3</string>
+	<key>IBOpenObjects</key>
+	<array>
+		<integer>195</integer>
+	</array>
+	<key>IBSystem Version</key>
+	<string>6I32</string>
+	<key>IBUserGuides</key>
+	<dict>
+		<key>195</key>
+		<dict>
+			<key>guideLocations</key>
+			<array>
+				<string>Horizontal:245.000000</string>
+			</array>
+			<key>guidesLocked</key>
+			<false/>
+		</dict>
+	</dict>
+</dict>
+</plist>
Index: /trunk/ICeCoffEE/ICeCoffEE/VERSION
===================================================================
--- /trunk/ICeCoffEE/ICeCoffEE/VERSION	(revision 105)
+++ /trunk/ICeCoffEE/ICeCoffEE/VERSION	(revision 106)
@@ -1,1 +1,1 @@
-1.3.1
+1.3.2b1
